VERSION 4.00
Begin VB.Form MESSAGE
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MESSAGE"
   ClientHeight    =   5280
   ClientLeft      =   1710
   ClientTop       =   1080
   ClientWidth     =   8520
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851}
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   5970
   Left            =   1650
   LinkTopic       =   "Form1"
   ScaleHeight     =   5280
   ScaleWidth      =   8520
   Top             =   450
   Width           =   8640
   Begin VB.CommandButton Command1
      Caption         =   "Command1"
      Height          =   480
      Left            =   6840
      TabIndex        =   0
      Top             =   120
      Width           =   1545
   End
   Begin VB.Menu menuLine
      Caption         =   "Line"
      Begin VB.Menu menuExit
         Caption         =   "E&xit"
      End
      Begin VB.Menu menuOnLine
         Caption         =   "OnLine"
      End
      Begin VB.Menu menuOffLine
         Caption         =   "OffLine"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu menuChange
      Caption         =   "Change"
      Begin VB.Menu menuPort
         Caption         =   "Port"
         Begin VB.Menu menuCOM1
            Caption         =   "COM1"
            Checked         =   -1  'True
         End
         Begin VB.Menu menuCOM2
            Caption         =   "COM2"
         End
         Begin VB.Menu menuCOM3
            Caption         =   "COM3"
         End
         Begin VB.Menu menuCOM4
            Caption         =   "COM4"
         End
      End
      Begin VB.Menu menuBaud
         Caption         =   "Baud"
         Begin VB.Menu menu110
            Caption         =   "110"
         End
         Begin VB.Menu menu300
            Caption         =   "300"
         End
         Begin VB.Menu menu1200
            Caption         =   "1200"
         End
         Begin VB.Menu menu2400
            Caption         =   "2400"
         End
         Begin VB.Menu menu4800
            Caption         =   "4800"
         End
         Begin VB.Menu menu9600
            Caption         =   "9600"
         End
         Begin VB.Menu menu19200
            Caption         =   "19200"
            Checked         =   -1  'True
         End
         Begin VB.Menu menu38400
            Caption         =   "38400"
         End
         Begin VB.Menu menu57600
            Caption         =   "57600"
         End
      End
   End
End
Attribute VB_Name = "MESSAGE"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

' MESSAGE.BAS

Option Explicit

Private Sub buttonTest_Click()
Const WM_ENABLE = &HA
Dim Code As Long
Code = PostMessage(Command1.hWnd, WM_ENABLE, 0, ByVal 0&)
End Sub

Private Sub ProcessKey(KeyAscii As Integer)
  Const WM_LBUTTONDOWN = &H201
  Const EV_RXCHAR = &H1
  Dim Code As Integer
  ' must kill message (thread) first (Windows 2000 requires this)
  Code = SioMessage(ThePort, 0, 0, 0)
  ' transmit the byte
  Code = SioPutc(ThePort, KeyAscii)
  Call GetIncoming
  ' start message thread again
  Code = SioMessage(ThePort, MESSAGE.Command1.hWnd, WM_LBUTTONDOWN, EV_RXCHAR)
  MESSAGE.SetFocus
  DoEvents
End Sub

' The Command1 button is used to receive messages send from WSC32.DLL
' Note that we use Command1_KeyPress rather than Form_KeyPress.
' Also note that Command1_Click is invoked when a carriage return is typed.

Private Sub Command1_KeyPress(KeyAscii As Integer)
Call ProcessKey(KeyAscii)
End Sub

' Command1_Click is called when user types a carriage return

Private Sub Command1_Click()
Call ProcessKey(13)
End Sub

' Command1_MouseDown is called when it receives a message from WSC32.DLL

Private Sub Command1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Const WM_LBUTTONDOWN = &H201
Const EV_RXCHAR = &H1
Dim Code As Long
Call GetIncoming
' request message from WSC upon arrival of more serial data
Code = SioMessage(ThePort, MESSAGE.Command1.hWnd, WM_LBUTTONDOWN, EV_RXCHAR)
MESSAGE.SetFocus
DoEvents
End Sub

Private Sub Form_Load()
   Dim Row As Integer
   BaudRateTable(0) = "110"
   BaudRateTable(1) = "300"
   BaudRateTable(2) = "1200"
   BaudRateTable(3) = "2400"
   BaudRateTable(4) = "4800"
   BaudRateTable(5) = "9600"
   BaudRateTable(6) = "19200"
   BaudRateTable(7) = "38400"
   BaudRateTable(8) = "57600"
   FatalFlag = 0
   ThePort = COM1
   TheBaudCode = Baud19200
   OnLineFlag = 0
   Command1.Left = 9000
   Call ShowConfig
   Call DisplayInit(MESSAGE)
End Sub

Private Sub menu110_Click()
  Call UncheckBaudRate
  menu110.Checked = True
  TheBaudCode = Baud110
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu1200_Click()
  Call UncheckBaudRate
  menu1200.Checked = True
  TheBaudCode = Baud1200
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu19200_Click()
  Call UncheckBaudRate
  menu19200.Checked = True
  TheBaudCode = Baud19200
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu2400_Click()
  Call UncheckBaudRate
  menu2400.Checked = True
  TheBaudCode = Baud2400
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu300_Click()
  Call UncheckBaudRate
  menu300.Checked = True
  TheBaudCode = Baud300
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu38400_Click()
  Call UncheckBaudRate
  menu38400.Checked = True
  TheBaudCode = Baud38400
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu4800_Click()
  Call UncheckBaudRate
  menu4800.Checked = True
  TheBaudCode = Baud4800
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu57600_Click()
  Call UncheckBaudRate
  menu57600.Checked = True
  TheBaudCode = Baud57600
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu9600_Click()
  Call UncheckBaudRate
  menu9600.Checked = True
  TheBaudCode = Baud9600
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menuCOM1_Click()
  Call UncheckComPorts
  menuCOM1.Checked = True
  ThePort = COM1
  Call ShowConfig
End Sub

Private Sub menuCOM2_Click()
  Call UncheckComPorts
  menuCOM2.Checked = True
  ThePort = COM2
  Call ShowConfig
End Sub

Private Sub menuCOM3_Click()
  Call UncheckComPorts
  menuCOM3.Checked = True
  ThePort = COM3
  Call ShowConfig
End Sub

Private Sub menuCOM4_Click()
  Call UncheckComPorts
  menuCOM4.Checked = True
  ThePort = COM4
  Call ShowConfig
End Sub

Private Sub menuExit_Click()
  Call GoOffLine
  End
End Sub

Private Sub menuOffLine_Click()
  menuChange.Enabled = True
  menuOffline.Enabled = False
  menuOnline.Enabled = True
  Call GoOffLine
  Call ShowConfig
End Sub

Private Sub menuOnLine_Click()
  menuOffline.Enabled = True
  menuOnline.Enabled = False
  menuChange.Enabled = False
  Call DisplayInit(MESSAGE)
  Call GoOnLine
  Call ShowConfig
  ' disable menu
  Call DisplayLine(MESSAGE, "[Online]")
End Sub

Private Sub UncheckBaudRate()
'uncheck all baud rates
menu110.Checked = False
menu300.Checked = False
menu1200.Checked = False
menu2400.Checked = False
menu4800.Checked = False
menu9600.Checked = False
menu19200.Checked = False
menu38400.Checked = False
menu57600.Checked = False
End Sub

Private Sub UncheckComPorts()
'uncheck all COM ports
menuCOM1.Checked = False
menuCOM2.Checked = False
menuCOM3.Checked = False
menuCOM4.Checked = False
End Sub



