VERSION 5.00
Begin VB.Form THREAD 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "THREAD"
   ClientHeight    =   5595
   ClientLeft      =   1665
   ClientTop       =   1905
   ClientWidth     =   8565
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5595
   ScaleWidth      =   8565
   Begin VB.Menu menuLine 
      Caption         =   "Line"
      Begin VB.Menu menuExit 
         Caption         =   "E&xit"
      End
      Begin VB.Menu menuOnLine 
         Caption         =   "OnLine"
      End
      Begin VB.Menu menuOffLine 
         Caption         =   "OffLine"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu menuChange 
      Caption         =   "Change"
      Begin VB.Menu menuPort 
         Caption         =   "Port"
         Begin VB.Menu menuCOM1 
            Caption         =   "COM1"
            Checked         =   -1  'True
         End
         Begin VB.Menu menuCOM2 
            Caption         =   "COM2"
         End
         Begin VB.Menu menuCOM3 
            Caption         =   "COM3"
         End
         Begin VB.Menu menuCOM4 
            Caption         =   "COM4"
         End
      End
      Begin VB.Menu menuBaud 
         Caption         =   "Baud"
         Begin VB.Menu menu110 
            Caption         =   "110"
         End
         Begin VB.Menu menu300 
            Caption         =   "300"
         End
         Begin VB.Menu menu1200 
            Caption         =   "1200"
         End
         Begin VB.Menu menu2400 
            Caption         =   "2400"
         End
         Begin VB.Menu menu4800 
            Caption         =   "4800"
         End
         Begin VB.Menu menu9600 
            Caption         =   "9600"
         End
         Begin VB.Menu menu19200 
            Caption         =   "19200"
            Checked         =   -1  'True
         End
         Begin VB.Menu menu38400 
            Caption         =   "38400"
         End
         Begin VB.Menu menu57600 
            Caption         =   "57600"
         End
      End
   End
End
Attribute VB_Name = "THREAD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' THREAD.BAS

Option Explicit

Private Sub Form_KeyPress(KeyAscii As Integer)
  Dim Code As Integer
  Dim ThreadID As Long
  '''THREAD.Print "["; Hex$(KeyAscii); "]";
  If KeyAscii <> 10 Then
    ' must kill thread first (Windows 2000 requires this)
    Code = TerminateThread(ThreadData.Handle, 0)
    'transmit the byte
    Code = SioPutc(ThePort, KeyAscii)
    'start thread again
    ThreadData.Handle = CreateThread(0, 0, AddressOf TheThread.TheThreadSub, ThreadData, 0, ThreadID)
  End If
End Sub

Private Sub Form_Load()
    Dim Row As Integer
    Dim TCode As Long
    BaudRateTable(0) = "110"
    BaudRateTable(1) = "300"
    BaudRateTable(2) = "1200"
    BaudRateTable(3) = "2400"
    BaudRateTable(4) = "4800"
    BaudRateTable(5) = "9600"
    BaudRateTable(6) = "19200"
    BaudRateTable(7) = "38400"
    BaudRateTable(8) = "57600"
    ThePort = COM1
    TheBaudCode = Baud19200
    OnLineFlag = 0
    Call ShowConfig
    Call DisplayInit(THREAD)
 End Sub

Private Sub menu110_Click()
  Call UncheckBaudRate
  menu110.Checked = True
  TheBaudCode = Baud110
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu1200_Click()
  Call UncheckBaudRate
  menu1200.Checked = True
  TheBaudCode = Baud1200
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu19200_Click()
  Call UncheckBaudRate
  menu19200.Checked = True
  TheBaudCode = Baud19200
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu2400_Click()
  Call UncheckBaudRate
  menu2400.Checked = True
  TheBaudCode = Baud2400
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu300_Click()
  Call UncheckBaudRate
  menu300.Checked = True
  TheBaudCode = Baud300
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu38400_Click()
  Call UncheckBaudRate
  menu38400.Checked = True
  TheBaudCode = Baud38400
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu4800_Click()
  Call UncheckBaudRate
  menu4800.Checked = True
  TheBaudCode = Baud4800
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu57600_Click()
  Call UncheckBaudRate
  menu57600.Checked = True
  TheBaudCode = Baud57600
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menu9600_Click()
  Call UncheckBaudRate
  menu9600.Checked = True
  TheBaudCode = Baud9600
  Call SetBaud
  Call ShowConfig
End Sub

Private Sub menuCOM1_Click()
  Call UncheckComPorts
  menuCOM1.Checked = True
  ThePort = COM1
  Call ShowConfig
End Sub

Private Sub menuCOM2_Click()
  Call UncheckComPorts
  menuCOM2.Checked = True
  ThePort = COM2
  Call ShowConfig
End Sub

Private Sub menuCOM3_Click()
  Call UncheckComPorts
  menuCOM3.Checked = True
  ThePort = COM3
  Call ShowConfig
End Sub

Private Sub menuCOM4_Click()
  Call UncheckComPorts
  menuCOM4.Checked = True
  ThePort = COM4
  Call ShowConfig
End Sub

Private Sub menuExit_Click()
  Call GoOffLine
  ' need STOP if running inside VB.
  Stop
  End
End Sub

Private Sub menuOffLine_Click()
  menuChange.Enabled = True
  menuOffLine.Enabled = False
  menuOnLine.Enabled = True
  Call GoOffLine
  Call ShowConfig
End Sub

Private Sub menuOnLine_Click()
  menuOffLine.Enabled = True
  menuOnLine.Enabled = False
  menuChange.Enabled = False
  Call DisplayInit(THREAD)
  Call GoOnLine
  Call ShowConfig
End Sub

Private Sub UncheckBaudRate()
'uncheck all baud rates
menu110.Checked = False
menu300.Checked = False
menu1200.Checked = False
menu2400.Checked = False
menu4800.Checked = False
menu9600.Checked = False
menu19200.Checked = False
menu38400.Checked = False
menu57600.Checked = False
End Sub

Private Sub UncheckComPorts()
'uncheck all COM ports
menuCOM1.Checked = False
menuCOM2.Checked = False
menuCOM3.Checked = False
menuCOM4.Checked = False
End Sub

