VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "Internet UK Telnet Server v0.01"
   ClientHeight    =   8235
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   15915
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin MSWinsockLib.Winsock sckServer 
      Index           =   0
      Left            =   1560
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock sckServerListener 
      Left            =   1080
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock sckTCP 
      Index           =   0
      Left            =   480
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock sckTCPListener 
      Left            =   0
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileMenu 
         Caption         =   "&Config"
         Index           =   0
      End
      Begin VB.Menu mnuFileMenu 
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu mnuFileMenu 
         Caption         =   "&Exit"
         Index           =   2
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      Begin VB.Menu mnuWindowMenu 
         Caption         =   "&Show Console Window"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim strUsername           As String
Dim strTCPData()          As String
Dim strServerList()       As String
Dim strServerData()       As String
Dim strPassword           As String
Dim intserverPort         As Integer
Dim intPWCount()          As Integer
Dim bLogoutafterPWFailure As Boolean
Dim bShowMOTD             As Boolean
Dim MOTD_Message          As String
Dim LockoutMessage        As String
Dim LogoffMsg             As String
Dim ConsolePrompt         As String
Private ServiceData       As clsServices


Private Sub MDIForm_Load()
    
    frmConsole.AddStatus "Internet UK Telnet Gateway v0.01"
    frmConsole.AddStatus "Server Initialising..."

    ' Load Console Window
    
        Load frmConsole
       
    ' Load Server Window
    
        Load frmServers
        frmServers.Left = frmConsole.Width + 100
        frmServers.Top = frmConsole.Top
        
    ReDim structTCP(0)
    ReDim structServer(0)
    ReDim strTCPData(0)
    ReDim structTelnet(0)
    ReDim telnetsocket(0)
    ReDim structACL(0)
    ReDim intPWCount(0)
    ReDim strServerList(0)
    
    ' Load Config
        
        Load_System_Config
        
    sckTCPListener.LocalPort = intserverPort
    sckTCPListener.Listen

    sckServerListener.LocalPort = intserverPort + 1
    sckServerListener.Listen
    
    frmConsole.AddStatus "Telnet Server listening on " & sckTCPListener.LocalIP & ":" & intserverPort
    frmConsole.AddStatus "Server Connection Manager listening on " & sckServerListener.LocalIP & ":" & intserverPort + 1
    
End Sub

Private Sub MDIForm_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    On Error Resume Next
    
    For nLoop = 0 To UBound(structTCP)
    
        If structTCP(nLoop).socket_state = socket_inuse Then
            sckTCP(structTCP(nLoop).socket_id).SendData "Telnet Server is shutting down..." & vbCrLf
            DoEvents
            sckTCP(structTCP(nLoop).socket_id).Close
            structTCP(nLoop).socket_state = socket_unused
            structTCP(nLoop).socket_id = 0
        End If
        
    Next nLoop
    
    sckTCPListener.Close
    
    Unload Me
    
    On Error GoTo 0
    
End Sub

Private Sub mnuFileMenu_Click(Index As Integer)

    Select Case Index
    
    Case 0
    
        frmConfig.Show
        
        
    
    Case 2
    
        Unload Me
        
    End Select
    
End Sub

Private Sub mnuWindowMenu_Click(Index As Integer)

    Select Case Index
    
    Case 0
        
        Load frmConsole
    
    End Select
    
End Sub

Private Sub sckServer_DataArrival(Index As Integer, ByVal bytesTotal As Long)

    Dim strInData As String
    
        sckServer(Index).GetData strInData, vbString
        
            sckServer(Index).SendData strInData
            
            strServerData(Index) = strServerData(Index) & strInData
                                        
            If InStr(strServerData(Index), vbCr) = 0 Then Exit Sub

        cmdPos = InStr(strServerData(Index), ":")
        
            If cmdPos > 0 Then
                cmdString = Replace(Left(strServerData(Index), cmdPos - 1), vbCrLf, "")
                paramString = Replace(Mid(strServerData(Index), cmdPos + 1, Len(strServerData(Index))), vbCrLf, "")
                
                If cmdString = "IDENTIFY" Then
                    
                    For nLoop = 0 To UBound(strServerList)
                        If strServerList(nLoop) = Trim(UCase(paramString)) Then
                        
                            frmServers.NewGridPosition
                            frmServers.grdServers.Col = 0
                            frmServers.grdServers.Text = Trim(UCase(paramString))
                            frmServers.grdServers.Col = 1
                            frmServers.grdServers.Text = "ONLINE"
                            sckServer(Index).SendData "OK:" & paramString & vbCrLf
                            sckServer(Index).SendData "FUNCTIONS" & vbCrLf
                                
                            Exit For
                        Else
                            sckServer(Index).SendData "Server '" & UCase(paramString) & "' is not permitted to connect to this system." & vbCrLf
                            DoEvents
                            sckServer(Index).Close
                        End If
                    Next nLoop
                    
                End If
            
                If cmdString = "FUNCTIONS" Then
                    
                    Dim funcArraY As Variant
                    funcArraY = Split(paramString, ",")
                    
                        For nLoop = 0 To UBound(funcArraY)
                            
                            Select Case funcArraY(nLoop)
                            
                                Case "SCM" ' Service Control Manager
                                    structServer(Index).ServiceControl = True
                                    sckServer(Index).SendData "FUNCTIONS:OK:SERVICECONTROL" & vbCrLf
                                Case "DMG"
                                    structServer(Index).DiskMgmt = True
                                    sckServer(Index).SendData "FUNCTIONS:OK:DISKMANAGEMENT" & vbCrLf
                                Case "RBC"
                                    structServer(Index).RebootControl = True
                                    sckServer(Index).SendData "FUNCTIONS:OK:REBOOTCONTROL" & vbCrLf
                                Case "SHL"
                                    structServer(Index).Shell = True
                                    sckServer(Index).SendData "FUNCTIONS:OK:SHELLSERVICES" & vbCrLf
                            End Select
                            
                        Next nLoop
                        
                End If
                
                cmdString = ""
                paramString = ""
                
            End If
            
    cmdString = ""
    paramString = ""
    strServerData(Index) = ""
    
End Sub

Private Sub sckServerListener_Close()

    sckServerListener.Listen
    
End Sub

Private Sub sckServerListener_ConnectionRequest(ByVal requestID As Long)

        Dim nLoop       As Integer
        Dim socket_id   As Integer
            
                For nLoop = 0 To UBound(structServer)
                
                    If structServer(nLoop).socket_state = socket_unused Then
                        structServer(nLoop).socket_state = socket_inuse
                        sckServer(structServer(nLoop).socket_id).Accept requestID
                        structServer(nLoop).ServerIP = sckServer(nLoop).RemoteHostIP
                        
                        socket_id = nLoop
                        Exit For
                    End If
                    
                Next nLoop
                
                If nLoop > UBound(structServer) Then
                    ReDim Preserve structServer(nLoop)
                    Load sckServer(nLoop)
                    ReDim Preserve strServerData(nLoop)
                    structServer(nLoop).socket_id = nLoop
                    structServer(nLoop).socket_state = socket_inuse
                    structServer(nLoop).ServerIP = sckServer(nLoop).RemoteHostIP
                    sckServer(nLoop).Accept requestID
                    socket_id = nLoop
                End If
        
                    sckServer(nLoop).SendData "IDENTIFY" & vbCrLf
                    
End Sub

Private Sub sckTCP_DataArrival(Index As Integer, ByVal bytesTotal As Long)

    Dim strInData As String
    
        sckTCP(Index).GetData strInData, vbString
        
            If Not structTCP(Index).bAcceptedID Then
            sckTCP(Index).SendData strInData
            End If
            
            If Len(strTCPData(Index)) <> 0 And InStr(strInData, Chr(8)) > 0 Then
                sckTCP(Index).SendData Chr(247)
                strTCPData(Index) = Left(strTCPData(Index), Len(strTCPData(Index)) - 1)
                Exit Sub
            End If
            
            strTCPData(Index) = strTCPData(Index) & strInData
                                        
            If InStr(strTCPData(Index), vbCr) = 0 Then Exit Sub

            ' Strip CR/LF from Input
            
                strTCPData(Index) = Replace(strTCPData(Index), vbCrLf, "")
                
            If Not structTCP(Index).bLoggedIn Then
            
                ' User is not logged on, accept only login requests
                
                If Not structTCP(Index).bAcceptedID Then
                
                    ' User has not provided User ID yet, check for user ID
                    
                    If Not ValidateUser(strTCPData(Index), Index) Then
                        sckTCP(Index).SendData "Login:"
                        frmConsole.AddStatus "Invalid username '" & strTCPData(Index) & "' from " & sckTCP(Index).RemoteHostIP
                    End If
                
                Else
                
                    ' Username has been accepted, get password
                    
                    If Not ValidatePassword(structTCP(Index).Username, strTCPData(Index), Index) Then
                    
                        sckTCP(Index).SendData vbCrLf & "Invalid Password" & vbCrLf
                        'structTCP(Index).bAcceptedID = False
                        sckTCP(Index).SendData "Password:"
                        frmConsole.AddStatus "Invalid Password '" & strTCPData(Index) & "' from User '" & structTCP(Index).Username & "' from " & sckTCP(Index).RemoteHostIP
                        If bLogoutafterPWFailure Then intPWCount(Index) = intPWCount(Index) + 1
                                                              
                    If intPWCount(Index) > 3 And bLogoutafterPWFailure Then
                        sckTCP(Index).SendData vbCrLf & "Error - Too many password attempts....Goodbye" & vbCrLf
                        DoEvents
                        sckTCP(Index).Close
                        structTCP(Index).socket_state = socket_unused
                        structTCP(Index).bLoggedIn = False
                        structTCP(Index).bAcceptedID = False
                    End If
                    
                    Else
                    
                        If IsLockedOut(structTCP(Index).Username, Index) Then
                        sckTCP(Index).SendData vbCrLf & LockoutMessage & vbCrLf & vbCrLf
                        frmConsole.AddStatus "Access denied to user '" & structTCP(Index).Username & "' - Account Locked Out"
                        DoEvents
                        sckTCP(Index).Close
                        structTCP(Index).bAcceptedID = False
                        structTCP(Index).bLoggedIn = False
                        structTCP(Index).socket_state = socket_unused
                        strTCPData(Index) = ""
                        Exit Sub
                        End If

                    End If
                    
            End If
       
            Else
            
            ProcessCommand strTCPData(), Index
            
       End If
       
       
    ' Clear Temp Data String
    
        strTCPData(Index) = ""
        
End Sub

Private Sub sckTCPListener_ConnectionRequest(ByVal requestID As Long)

        Dim nLoop       As Integer
        Dim socket_id   As Integer
            
                For nLoop = 0 To UBound(structTCP)
                
                    If structTCP(nLoop).socket_state = socket_unused Then
                        structTCP(nLoop).socket_state = socket_inuse
                        sckTCP(structTCP(nLoop).socket_id).Accept requestID
                        socket_id = nLoop
                        Exit For
                    End If
                    
                Next nLoop
                
                If nLoop > UBound(structTCP) Then
                    ReDim Preserve structTCP(nLoop)
                    ReDim Preserve strTCPData(nLoop)
                    ReDim Preserve intPWCount(nLoop)
                    Load sckTCP(nLoop)
                    structTCP(nLoop).socket_id = nLoop
                    structTCP(nLoop).socket_state = socket_inuse
                    sckTCP(nLoop).Accept requestID
                    socket_id = nLoop
                End If
        
    
    For nLoop = 0 To UBound(structACL)
    
        If boolMaskCompare(structACL(nLoop).PermittedIP, sckTCP(socket_id).RemoteHostIP) Then
            bMatched = True
            Exit For
        Else
            bMatched = False
        End If

    Next nLoop
    
    If bMatched = False Then
    sckTCP(socket_id).SendData "Access from this IP is not permitted." & vbCrLf
    DoEvents
    sckTCP(socket_id).Close
    structTCP(socket_id).socket_state = socket_unused
    frmConsole.AddStatus "Access denied due to ACL match on ip " & sckTCP(socket_id).RemoteHostIP
    Exit Sub
    End If
    
        
    
    
    sendMOTD_Message = Replace(MOTD_Message, "$IPADDRESS", sckTCP(socket_id).RemoteHostIP)
    
    If bShowMOTD Then
    sckTCP(socket_id).SendData sendMOTD_Message & vbCrLf & vbCrLf
    End If
    
    sckTCP(socket_id).SendData "Login:"
    
    frmConsole.AddStatus "Incoming Connection from " & sckTCP(socket_id).RemoteHostIP
    
    intPWCount(socket_id) = 1
    
End Sub

Private Sub sckTCPListener_Close()

    sckTCPListener.Listen
    
End Sub

Private Sub sckTCP_Close(Index As Integer)

frmConsole.AddStatus "Connection terminated to " & sckTCP(Index).RemoteHostIP
DoEvents
DoEvents

    Dim nLoop As Integer
    
        For nLoop = 0 To UBound(structTCP)
        
            If structTCP(nLoop).socket_id = Index Then
                sckTCP(Index).Close
                structTCP(nLoop).socket_state = socket_unused
                structTCP(Index).bAcceptedID = False
                structTCP(Index).bLoggedIn = False
            End If
            
        Next nLoop

    
    
End Sub

Private Sub ProcessCommand(strTCPData() As String, Index)

    Dim strCmd      As String
    Dim strParams   As String
    
    ' Extract the command
    
        intPos = InStr(strTCPData(Index), " ")
        
            If intPos > 0 Then
                strCmd = Left(strTCPData(Index), intPos)
                strParams = Mid(strTCPData(Index), intPos + 1, Len(strTCPData(Index)))
            Else
                strCmd = strTCPData(Index)
            End If
            
            Select Case UCase(Trim(strCmd))
            
                Case "QUIT", "EXIT"
                
                    sckTCP(Index).SendData vbCrLf & LogoffMsg & vbCrLf
                    sckTCP(Index).SendData vbCrLf & "User '" & structTCP(Index).Username & "' logging off at " & Format(Now, "hh:mm") & " on the " & Format(Now, "dd mmm yyyy") & vbCrLf
                    DoEvents
                    sckTCP(Index).Close
                    structTCP(Index).socket_state = socket_unused
                    structTCP(Index).bLoggedIn = False
                    structTCP(Index).bAcceptedID = False
                    frmConsole.AddStatus "User '" & structTCP(Index).Username & "' has logged off"
                
                Case "HELP", "?"
                
                    sckTCP(Index).SendData vbCrLf & "Gateway Help" & vbCrLf
                    sckTCP(Index).SendData "------------" & vbCrLf & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "QUIT/EXIT           - Logs you off the system. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "TIME/TI             - Displays the current time. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "DATE/DA             - Displays today's date. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "SAY                 - Sends a message to another online user. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "WHO                 - Displays a list of all online users. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "PASSWD              - Change your password. (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= SysOp Then sckTCP(Index).SendData "KILL                - Kill another user's connection (Level 5)" & vbCrLf
                    If structTCP(Index).AccessLevel >= SysOp Then sckTCP(Index).SendData "REVOKE              - Revoke a users right to logon (Level 5)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "WHOAMI              - Displays paramaters about yourself (Level 1)" & vbCrLf
                    If structTCP(Index).AccessLevel >= Administrator Then sckTCP(Index).SendData "SERVICELIST/SL      - Display services on the current machine (Level 2)" & vbCrLf
                    If structTCP(Index).AccessLevel >= Administrator Then sckTCP(Index).SendData "SERVICECONTROL/SC   - Start/Stop/Pause/Restart/Resume a Service (Level 2)" & vbCrLf
                    If structTCP(Index).AccessLevel >= Administrator Then sckTCP(Index).SendData "SPAWN               - Spawns a process on the remote machine (Level 2)" & vbCrLf
                    If structTCP(Index).AccessLevel >= User Then sckTCP(Index).SendData "HELP/?              - Displays Help" & vbCrLf
            
                    sckTCP(Index).SendData vbCrLf & "No more help available" & vbCrLf & vbCrLf
                    
                Case "TIME", "TI"
                
                    sckTCP(Index).SendData "The current time is " & Format(Now, "hh:mm:ss") & vbCrLf
                    
                Case "DATE", "DA"
                
                    sckTCP(Index).SendData "Today's date is " & Format(Now, "dd mmm yyyy") & vbCrLf
                
                Case "SAY"
                
                    
                    ' Check for the existance of the user they want to talk to
                    
                        strToPos = InStr(strParams, " ")
                        
                            If strToPos > 0 Then
                                strTo = Trim(Left(strParams, strToPos))
                                strMessageString = Mid(strParams, strToPos + 1, Len(strParams))
                            Else
                                sckTCP(Index).SendData "Incomplete Command" & vbCrLf
                                sckTCP(Index).SendData "Usage : SAY <username> <message>" & vbCrLf
                                sckTCP(Index).SendData ConsolePrompt
                                Exit Sub
                            End If
                            
                        For nLoop = 0 To UBound(structTCP)
                
                            If structTCP(nLoop).Username = strTo And _
                               structTCP(nLoop).bLoggedIn Then
                                sckTCP(structTCP(nLoop).socket_id).SendData vbCrLf & "[" & structTCP(Index).Username & "] " & strMessageString & vbCrLf
                                DoEvents
                                sckTCP(Index).SendData "Message sent to " & strTo & vbCrLf
                                sckTCP(Index).SendData ConsolePrompt
                                Exit Sub
                            End If
                            
                        Next nLoop
                        
                        sckTCP(Index).SendData "'" & strTo & "' was not found on the system" & vbCrLf
                                
                Case "WHO"
                
                    ' Send list of currently online users.
                    
                        sckTCP(Index).SendData "Currently Logged In Users" & vbCrLf
                        sckTCP(Index).SendData "-------------------------" & vbCrLf & vbCrLf
                        sckTCP(Index).SendData "Username" & Space(12) & "Real Name" & Space(10) & "Session ID" & vbCrLf
                        sckTCP(Index).SendData "--------" & Space(12) & "---------" & Space(10) & "----------" & vbCrLf
                        
                        For nLoop = 0 To UBound(structTCP)
                        
                            If structTCP(nLoop).bLoggedIn Then
                                    sckTCP(Index).SendData structTCP(nLoop).Username & Space(20 - Len(structTCP(nLoop).Username)) & _
                                    structTCP(nLoop).RealName & Space(20 - Len(structTCP(nLoop).RealName)) & structTCP(nLoop).socket_id & vbCrLf
                            End If
                            
                        Next nLoop
                        
                        sckTCP(Index).SendData vbCrLf
                                                
                                                
                Case "PASSWD"
                
                    Dim PasswordString As String
                    
                    ' Change online user's password
                        
                        PasswordString = Trim(strParams)
                        
                            If Len(strParams) < 2 Then
                                sckTCP(Index).SendData "Incomplete Command, usage : PASSWD <newpassword>" & vbCrLf
                                
                            Else
                            
                            frmConsole.AddStatus "Changing Password for user '" & structTCP(Index).Username & "'"
                            
                            If Not UpdateUserPassword(PasswordString, CInt(Index)) Then
                                sckTCP(Index).SendData "There has been a problem changing your password, please see the system administrator" & vbCrLf
                            End If
                            
                            End If
                
                Case "SERVICELIST", "SL"
                    
                            If strParams <> "" Then
                                vArray = EnumerateServices(strParams)
                            Else
                                vArray = EnumerateServices
                            End If
                            
                                If strParams = "" Then
                                    sckTCP(Index).SendData "Service List of LOCALHOST" & vbCrLf & vbCrLf
                                Else
                                    sckTCP(Index).SendData "Service List of " & strParams & vbCrLf & vbCrLf
                                End If
                                
                                On Error Resume Next
                                For nLoop = 0 To UBound(vArray) Step 4
                                    If Len(CStr(vArray(nLoop))) = 1 Then
                                        nCount = "0" & CStr(vArray(nLoop))
                                    Else
                                        nCount = CStr(vArray(nLoop))
                                    End If
                                    
                                    sckTCP(Index).SendData nCount & Space(4) & vArray(nLoop + 1) & Space(4) & vArray(nLoop + 2) & Space(50 - Len(vArray(nLoop + 2))) & vArray(nLoop + 3) & vbCrLf
                                Next nLoop
                                On Error GoTo 0
                                
                           sckTCP(Index).SendData vbCrLf & vbCrLf
                           sckTCP(Index).SendData "TIP: To show services on another computer, type SERVICELIST <machinename>" & vbCrLf
                           
                           If strParams <> "" Then
                                frmConsole.AddStatus "User '" & structTCP(Index).Username & "' is browsing services on " & strParams
                           Else
                                frmConsole.AddStatus "User '" & structTCP(Index).Username & "' is browsing services on LOCALHOST"
                           End If
                           
                Case "SERVICECONTROL", "SC"
                
                        If strParams = "" Then
                            sckTCP(Index).SendData "Incomplete Command" & vbCrLf
                            sckTCP(Index).SendData "USAGE: SERVICECONTROL <machine name> <service number> <START|STOP|PAUSE|RESTART|RESUME>" & vbCrLf
                        
                        Else
                                
                                vCmd = Split(strParams, " ")
                                
                                If UBound(vCmd) < 2 Then
                                    
                                    sckTCP(Index).SendData "Incomplete Command" & vbCrLf
                                    sckTCP(Index).SendData "USAGE: SERVICECONTROL <machine name> <service number> <START|STOP|PAUSE|RESTART|RESUME>" & vbCrLf
                                    sckTCP(Index).SendData ConsolePrompt
                                    Exit Sub
                                
                                End If

                            Set ServiceData = New clsServices
                            
                                    strMachine = UCase(CStr(vCmd(0)))
                                    iServiceNumber = CInt(vCmd(1))
                                    strCommand = CStr(vCmd(2))
                                    
                                    ServiceData.ComputerName = strMachine
                                    
                                    Select Case UCase(strCommand)
                                    
                                        Case "START"
                                            sckTCP(Index).SendData "Attempting to start the '" & ServiceData(iServiceNumber).DisplayName & "' ..... "
                                            sckTCP(Index).SendData SControl(CStr(strMachine), CInt(iServiceNumber), CStr(strCommand))
                                            sckTCP(Index).SendData vbCrLf
                                            frmConsole.AddStatus "User '" & structTCP(Index).Username & "' started service '" & ServiceData(iServiceNumber).DisplayName & " on " & CStr(strMachine)
                                        
                                        Case "STOP"
                                            sckTCP(Index).SendData "Attempting to stop the '" & ServiceData(iServiceNumber).DisplayName & "' ..... "
                                            sckTCP(Index).SendData SControl(CStr(strMachine), CInt(iServiceNumber), CStr(strCommand))
                                            sckTCP(Index).SendData vbCrLf
                                            frmConsole.AddStatus "User '" & structTCP(Index).Username & "' stopped service '" & ServiceData(iServiceNumber).DisplayName & " on " & CStr(strMachine)
                                            
                                        Case "PAUSE"
                                            sckTCP(Index).SendData "Attempting to pause the '" & ServiceData(iServiceNumber).DisplayName & "' ..... "
                                            sckTCP(Index).SendData SControl(CStr(strMachine), CInt(iServiceNumber), CStr(strCommand))
                                            sckTCP(Index).SendData vbCrLf
                                            frmConsole.AddStatus "User '" & structTCP(Index).Username & "' paused service '" & ServiceData(iServiceNumber).DisplayName & " on " & CStr(strMachine)
                                    
                                        Case "RESTART"
                                            sckTCP(Index).SendData "Attempting to restart the '" & ServiceData(iServiceNumber).DisplayName & "' ..... "
                                            sckTCP(Index).SendData SControl(CStr(strMachine), CInt(iServiceNumber), "RESTART")
                                            sckTCP(Index).SendData vbCrLf
                                            frmConsole.AddStatus "User '" & structTCP(Index).Username & "' restarted service '" & ServiceData(iServiceNumber).DisplayName & " on " & CStr(strMachine)
                                            
                                        Case "RESUME"
                                            sckTCP(Index).SendData "Attempting to resume the '" & ServiceData(iServiceNumber).DisplayName & "' ..... "
                                            sckTCP(Index).SendData SControl(CStr(strMachine), CInt(iServiceNumber), "RESUME")
                                            sckTCP(Index).SendData vbCrLf
                                            frmConsole.AddStatus "User '" & structTCP(Index).Username & "' resumed service '" & ServiceData(iServiceNumber).DisplayName & " on " & CStr(strMachine)
                                    
                                    End Select
                        
                                    
                                    
                        End If
                            
                Case "KILL"
                
                    If Trim(strParams) <> "" Then
                    If structTCP(Index).AccessLevel >= SystemAdministrator Then
                        
                            For nLoop = 0 To UBound(structTCP)
                                If structTCP(nLoop).Username = Trim(strParams) Then
                                frmConsole.AddStatus "User '" & structTCP(nLoop).Username & "' was terminated by " & structTCP(Index).Username
                                sckTCP(Index).SendData "Killing user '" & structTCP(nLoop).Username & "'" & vbCrLf
                                DoEvents
                                sckTCP(structTCP(nLoop).socket_id).SendData vbCrLf & "SYSTEM : Your connection has been terminated." & vbCrLf
                                DoEvents
                                sckTCP(structTCP(nLoop).socket_id).Close
                                structTCP(structTCP(nLoop).socket_id).socket_state = socket_unused
                                structTCP(structTCP(nLoop).socket_id).bLoggedIn = False
                                structTCP(structTCP(nLoop).socket_id).bAcceptedID = False
                                strTCPData(Index) = ""
                                sckTCP(Index).SendData ConsolePrompt
                                Exit Sub
                                End If
                            Next nLoop
                    Else
                    
                        sckTCP(Index).SendData "Isufficient Access Level, Level 5 or greater required." & vbCrLf
                        sckTCP(Index).SendData ConsolePrompt
                        Exit Sub
                        
                    End If
                    
                    sckTCP(Index).SendData "Error, User '" & strParams & "' was not found on the system" & vbCrLf
                        
                    Else
                    
                        sckTCP(Index).SendData "Incomplete Command - KILL <username>" & vbCrLf
                    
                    End If
                    
                Case "REVOKE"
                
                    If structTCP(Index).AccessLevel >= SuperUser Then
                    
                                rsUsers.MoveFirst
                                
                                    Do While Not rsUsers.EOF
                                        If rsUsers!Userid = Trim(strParams) Then
                                            With rsUsers
                                                .Edit
                                                !LockedOut = True
                                                .Update
                                            End With
                                        End If
                                    rsUsers.MoveNext
                                    Loop
                                    sckTCP(Index).SendData "'" & strParams & "' access rights have been revoked." & vbCrLf
                                    
                    Else
                    
                        sckTCP(Index).SendData "Isufficient Access Level, Level 5 or greater required." & vbCrLf
                        sckTCP(Index).SendData ConsolePrompt
                        Exit Sub
                    
                    End If
                        
                Case "WHOAMI"
                
                    sckTCP(Index).SendData "You are user '" & structTCP(Index).Username & "' (" & structTCP(Index).RealName & ")" & vbCrLf & "Access Level : " & GetAL(CInt(structTCP(Index).AccessLevel)) & vbCrLf & "Last Logged In : " & CStr(structTCP(Index).Last_Logon) & vbCrLf & vbCrLf
                    
                Case "SPAWN"
                
                    If strParams <> "" Then
                        sckTCP(Index).SendData "Spawning .... "
                        sckTCP(Index).SendData SpawnProcess(strParams) & vbCrLf
                    Else
                        sckTCP(Index).SendData "Incomplete Command" & vbCrLf
                        sckTCP(Index).SendData "USAGE: SPAWN <filename>" & vbCrLf
                    End If
                    
                       
            End Select
                    
        
        ' Send the prompt
        
        If UCase(strCmd) <> "QUIT" And UCase(strCmd) <> "EXIT" Then
        sckTCP(Index).SendData ConsolePrompt
        End If
        
End Sub

Public Sub Load_System_Config()

    ' Open Database
    
        Set db = OpenDatabase(App.Path & "\telnet.mdb")
        Set rsUsers = db.OpenRecordset("Users")
        Set rsACL = db.OpenRecordset("ACL")
        
    intserverPort = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\General", "Server_Port", 23)
    bLogoutafterPWFailure = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\General", "User_PW_Fail_Disconnect", 1)
    bShowMOTD = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Messages", "Show_MOTD", 1)
    MOTD_Message = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Messages", "MOTD", "Internet UK Telnet Server" & vbCrLf & "(C)2000 Internet UK Services Ltd" & vbCrLf)
    LockoutMessage = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Messages", "LockOut_Msg", "")
    LogoffMsg = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Messages", "Logoff_Msg", "")
    ConsolePrompt = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Messages", "Console_Prompt", "gateway>")
    frmConsole.AddStatus "Configuration Loaded"
    intServers = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Servers", "Num_Servers", 0)
    
        ReDim Preserve strServerList(intServers)
        
            For nLoop = 0 To intServers
                strServerList(nLoop) = ReadRegistry(HKEY_LOCAL_MACHINE, "Software\Internet UK\Telnet Server\Servers", "Server" & Trim(Str(nLoop)), "")
            Next nLoop
            
        Index = 0
        
        rsACL.MoveFirst
        
            Do While Not rsACL.EOF
            
                ReDim Preserve structACL(Index)
                structACL(Index).PermittedIP = rsACL!PermittedIP
                Index = Index + 1
                rsACL.MoveNext
            
            Loop
            
End Sub

Private Function ValidateUser(sUserName As String, Index As Integer) As Boolean

    rsUsers.MoveFirst
    
    ValidateUser = False
    
        Do While Not rsUsers.EOF
        
            If Trim(sUserName) = rsUsers!Userid Then
                ValidateUser = True
                structTCP(Index).RealName = rsUsers!RealName
                frmConsole.AddStatus "System recognised '" & structTCP(Index).RealName & "' Waiting for password."
                sckTCP(Index).SendData "Password:"
                structTCP(Index).bAcceptedID = True
                structTCP(Index).Username = rsUsers!Userid
                structTCP(Index).AccessLevel = rsUsers!AccessLevel
                Exit Do
            End If
            
        rsUsers.MoveNext
        
        Loop
                
End Function

Private Function ValidatePassword(sUserName As String, sPassword As String, Index As Integer) As Boolean



    rsUsers.MoveFirst
    
    ValidatePassword = False
    
        Do While Not rsUsers.EOF
        
            If Trim(sPassword) = rsUsers!UserPassword And Trim(sUserName) = rsUsers!Userid Then
                                
                ValidatePassword = True
                
                If Not IsNull(rsUsers!LastLogon) Then
                structTCP(Index).Last_Logon = rsUsers!LastLogon
                Else
                structTCP(Index).Last_Logon = "N/A"
                End If
                
                If rsUsers!LockedOut = False Then
                sckTCP(Index).SendData vbCrLf & "Welcome back " & rsUsers!RealName & vbCrLf
                sckTCP(Index).SendData "Your session ID is " & Index & vbCrLf
                sckTCP(Index).SendData "Your current security level is " & GetAL(rsUsers!AccessLevel) & vbCrLf
                sckTCP(Index).SendData "Your last logon was on the " & structTCP(Index).Last_Logon & vbCrLf & "The time is currently " & Format(Now, "hh:mm") & " on the " & Format(Now, "dd mmm yyyy") & vbCrLf & vbCrLf
                
                structTCP(Index).Last_Logon = Format(Now, "dd mmm yyyy")
                
                rsUsers.Edit
                rsUsers!LastLogon = Format(Now, "dd mmm yyyy - hh:mm:ss")
                rsUsers.Update
                sckTCP(Index).SendData vbCrLf & "User logged on sucessfully" & vbCrLf & vbCrLf
                
                sckTCP(Index).SendData ConsolePrompt
                structTCP(Index).bLoggedIn = True
                structTCP(Index).bAcceptedID = False
                structTCP(Index).Password = rsUsers!UserPassword
                frmConsole.AddStatus "User '" & rsUsers!Userid & "' has been logged onto the system."
                
                
                End If
                Exit Do
            End If
            
        rsUsers.MoveNext
        
        Loop
        
End Function

Private Function UpdateUserPassword(sPassword As String, Index As Integer) As Boolean

    UpdateUserPassword = False
    
        rsUsers.MoveFirst
        
            Do While Not rsUsers.EOF
            
                If structTCP(Index).Username = rsUsers!Userid Then
                
                    With rsUsers
                        .Edit
                        !UserPassword = Trim(sPassword)
                        .Update
                    End With
                    
                    UpdateUserPassword = True
                    
                    sckTCP(Index).SendData "Your password has been updated sucessfully." & vbCrLf
                    frmConsole.AddStatus "Password changed for user '" & structTCP(Index).Username & "'"
                    Exit Do
                    
                End If
                
            rsUsers.MoveNext
            
            Loop
        
End Function

Private Function IsLockedOut(sUserName, Index) As Boolean

        rsUsers.MoveFirst
        IsLockedOut = False
        
        Do While Not rsUsers.EOF
        
        If rsUsers!LockedOut = True And rsUsers!Userid = structTCP(Index).Username Then
            IsLockedOut = True
        End If
        
        rsUsers.MoveNext
        
        Loop

End Function

